/*
 * Created on 2006/10/25
 *
 *
 * Copyright(c) 2006 Yoshimasa Matsumoto
 */
package netjfwatcher.honeyport.view;

import org.eclipse.jface.resource.FontRegistry;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.viewers.IFontProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;

public class HoneyPortScanTableViewLabelProvider implements
		ITableLabelProvider, IFontProvider {

	public static final int PORT_SCAN_TABLE_ARRAY_COUNT = 6;

	public static final int NO = 0;

	public static final int IP_ADDRESS = 1;

	public static final int PORT = 2;

	public static final int START_DATE = 3;

	public static final int CHECK_DATE = 4;

	public static final int CHECK_COUNT = 5;

	public static final String[] COLUMNS = new String[] { "No", "IP Address",
			"Port", "Start Date", "Scan Date", "Scan Count" };

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.
	 *      ITableLabelProvider#getColumnImage(java.lang.Object, int)
	 */
	public Image getColumnImage(Object element, int columnIndex) {
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.
	 *      ITableLabelProvider#getColumnText(java.lang.Object, int)
	 */
	public String getColumnText(Object element, int columnIndex) {
		String[] test = (String[]) element;

		return test[columnIndex];
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IFontProvider#getFont(java.lang.Object)
	 */
	public Font getFont(Object element) {
		FontRegistry fr = JFaceResources.getFontRegistry();

		return fr.get(JFaceResources.DEFAULT_FONT);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.
	 *      IBaseLabelProvider#isLabelProperty(java.lang.Object,
	 *      java.lang.String)
	 */
	public boolean isLabelProperty(Object element, String property) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.
	 *      IBaseLabelProvider#addListener(org.eclipse.jface.viewers.
	 *      ILabelProviderListener)
	 */
	public void addListener(ILabelProviderListener listener) {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IBaseLabelProvider#dispose()
	 */
	public void dispose() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.
	 *      IBaseLabelProvider#removeListener(org.eclipse.jface.viewers.ILabelProviderListener)
	 */
	public void removeListener(ILabelProviderListener listener) {
	}
}
